> For the complete documentation index, see [llms.txt](https://docs.openmind.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.openmind.com/developer-cookbook/om1-integration-with-different-machines/tesla_dimo.md).

# Tesla Dimo

We work with DIMO to bring your Tesla to life. This plugin allows you to read data from your Tesla and control it.

### Prerequisites

#### Step 0: Install the DIMO App

Before you can use the DIMO APIs, you need to install the DIMO app on your phone and connect it to your Tesla.

#### Step 1: Get a Developer License

To access the DIMO APIs, you must first obtain and configure a [Developer License](https://docs.dimo.org/developer-platform/developer-guide/developer-console#getting-a-license) from DIMO.

Once you have the license, you will receive the following credentials: `Client ID`, `API key`, and `Redirect URI`.

#### Step 2: Log in with DIMO

Replace `<Client ID>` and `<Redirect URI>` with your own credentials, then open the following URL in your browser to log in with DIMO and authorize your application to access your Tesla data. You will obtain your `car ID` (`token_id`) on the permission page.

```dimo
https://login.dimo.org/?clientId=<Client ID>&redirectUri=<Redirect URI>&permissionTemplateId=1&entryState=VEHICLE_MANAGER
```

#### Step 3: Set up the Tesla Virtual Key

Go to the [Tesla Virtual Key](https://www.tesla.com/_ak/auth.drivedimo.com) page and follow the instructions to set up the virtual key for DIMO.

If everything is set up correctly, you should be able to view your Tesla data in the DIMO app and control your Tesla via the DIMO API.

> **Note:** If you encounter any issues, please refer to the [DIMO documentation](https://docs.dimo.org/developer-platform/developer-guide/dimo-developer-sdks/data-sdk).

### Basic Commands

Run

```bash
make run CONFIG=tesla
```

### Configuration

Provide the Dimo `client_id`, `domain`, `private_key` and `token_id` obtained from the previous steps in your configuration file (`/config.tesla.json5`):

```bash
    "client_id": "",
    "domain": "",
    "private_key": "",
    "token_id": 0
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.openmind.com/developer-cookbook/om1-integration-with-different-machines/tesla_dimo.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
